/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class PhysicsBoxGeom!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILEPHYSICSBOXGEOMINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGPhysicsBoxGeomBase.h"
#include "OSGPhysicsBoxGeom.h"


OSG_USING_NAMESPACE

const OSG::BitVector  PhysicsBoxGeomBase::LenghtsFieldMask = 
    (TypeTraits<BitVector>::One << PhysicsBoxGeomBase::LenghtsFieldId);

const OSG::BitVector PhysicsBoxGeomBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var Vec3f           PhysicsBoxGeomBase::_sfLenghts
    
*/

//! PhysicsBoxGeom description

FieldDescription *PhysicsBoxGeomBase::_desc[] = 
{
    new FieldDescription(SFVec3f::getClassType(), 
                     "lenghts", 
                     LenghtsFieldId, LenghtsFieldMask,
                     false,
                     (FieldAccessMethod) &PhysicsBoxGeomBase::getSFLenghts)
};


FieldContainerType PhysicsBoxGeomBase::_type(
    "PhysicsBoxGeom",
    "PhysicsGeom",
    NULL,
    (PrototypeCreateF) &PhysicsBoxGeomBase::createEmpty,
    PhysicsBoxGeom::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(PhysicsBoxGeomBase, PhysicsBoxGeomPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &PhysicsBoxGeomBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &PhysicsBoxGeomBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr PhysicsBoxGeomBase::shallowCopy(void) const 
{ 
    PhysicsBoxGeomPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const PhysicsBoxGeom *>(this)); 

    return returnValue; 
}

UInt32 PhysicsBoxGeomBase::getContainerSize(void) const 
{ 
    return sizeof(PhysicsBoxGeom); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsBoxGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((PhysicsBoxGeomBase *) &other, whichField);
}
#else
void PhysicsBoxGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((PhysicsBoxGeomBase *) &other, whichField, sInfo);
}
void PhysicsBoxGeomBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void PhysicsBoxGeomBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

PhysicsBoxGeomBase::PhysicsBoxGeomBase(void) :
    _sfLenghts                (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

PhysicsBoxGeomBase::PhysicsBoxGeomBase(const PhysicsBoxGeomBase &source) :
    _sfLenghts                (source._sfLenghts                ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

PhysicsBoxGeomBase::~PhysicsBoxGeomBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 PhysicsBoxGeomBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (LenghtsFieldMask & whichField))
    {
        returnValue += _sfLenghts.getBinSize();
    }


    return returnValue;
}

void PhysicsBoxGeomBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (LenghtsFieldMask & whichField))
    {
        _sfLenghts.copyToBin(pMem);
    }


}

void PhysicsBoxGeomBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (LenghtsFieldMask & whichField))
    {
        _sfLenghts.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsBoxGeomBase::executeSyncImpl(      PhysicsBoxGeomBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (LenghtsFieldMask & whichField))
        _sfLenghts.syncWith(pOther->_sfLenghts);


}
#else
void PhysicsBoxGeomBase::executeSyncImpl(      PhysicsBoxGeomBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (LenghtsFieldMask & whichField))
        _sfLenghts.syncWith(pOther->_sfLenghts);



}

void PhysicsBoxGeomBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<PhysicsBoxGeomPtr>::_type("PhysicsBoxGeomPtr", "PhysicsGeomPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(PhysicsBoxGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(PhysicsBoxGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);

OSG_END_NAMESPACE


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: OSGPhysicsBoxGeomBase.cpp,v 1.2 2006/02/20 17:04:20 dirk Exp $";
    static Char8 cvsid_hpp       [] = OSGPHYSICSBOXGEOMBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGPHYSICSBOXGEOMBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGPHYSICSBOXGEOMFIELDS_HEADER_CVSID;
}

