/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class PhysicsRayGeom!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILEPHYSICSRAYGEOMINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGPhysicsRayGeomBase.h"
#include "OSGPhysicsRayGeom.h"


OSG_USING_NAMESPACE

const OSG::BitVector  PhysicsRayGeomBase::LenghtFieldMask = 
    (TypeTraits<BitVector>::One << PhysicsRayGeomBase::LenghtFieldId);

const OSG::BitVector PhysicsRayGeomBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var Real32          PhysicsRayGeomBase::_sfLenght
    
*/

//! PhysicsRayGeom description

FieldDescription *PhysicsRayGeomBase::_desc[] = 
{
    new FieldDescription(SFReal32::getClassType(), 
                     "lenght", 
                     LenghtFieldId, LenghtFieldMask,
                     false,
                     (FieldAccessMethod) &PhysicsRayGeomBase::getSFLenght)
};


FieldContainerType PhysicsRayGeomBase::_type(
    "PhysicsRayGeom",
    "PhysicsGeom",
    NULL,
    (PrototypeCreateF) &PhysicsRayGeomBase::createEmpty,
    PhysicsRayGeom::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(PhysicsRayGeomBase, PhysicsRayGeomPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &PhysicsRayGeomBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &PhysicsRayGeomBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr PhysicsRayGeomBase::shallowCopy(void) const 
{ 
    PhysicsRayGeomPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const PhysicsRayGeom *>(this)); 

    return returnValue; 
}

UInt32 PhysicsRayGeomBase::getContainerSize(void) const 
{ 
    return sizeof(PhysicsRayGeom); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsRayGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((PhysicsRayGeomBase *) &other, whichField);
}
#else
void PhysicsRayGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((PhysicsRayGeomBase *) &other, whichField, sInfo);
}
void PhysicsRayGeomBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void PhysicsRayGeomBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

PhysicsRayGeomBase::PhysicsRayGeomBase(void) :
    _sfLenght                 (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

PhysicsRayGeomBase::PhysicsRayGeomBase(const PhysicsRayGeomBase &source) :
    _sfLenght                 (source._sfLenght                 ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

PhysicsRayGeomBase::~PhysicsRayGeomBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 PhysicsRayGeomBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (LenghtFieldMask & whichField))
    {
        returnValue += _sfLenght.getBinSize();
    }


    return returnValue;
}

void PhysicsRayGeomBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (LenghtFieldMask & whichField))
    {
        _sfLenght.copyToBin(pMem);
    }


}

void PhysicsRayGeomBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (LenghtFieldMask & whichField))
    {
        _sfLenght.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsRayGeomBase::executeSyncImpl(      PhysicsRayGeomBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (LenghtFieldMask & whichField))
        _sfLenght.syncWith(pOther->_sfLenght);


}
#else
void PhysicsRayGeomBase::executeSyncImpl(      PhysicsRayGeomBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (LenghtFieldMask & whichField))
        _sfLenght.syncWith(pOther->_sfLenght);



}

void PhysicsRayGeomBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<PhysicsRayGeomPtr>::_type("PhysicsRayGeomPtr", "PhysicsGeomPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(PhysicsRayGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(PhysicsRayGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);

OSG_END_NAMESPACE


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: OSGPhysicsRayGeomBase.cpp,v 1.2 2006/02/20 17:04:21 dirk Exp $";
    static Char8 cvsid_hpp       [] = OSGPHYSICSRAYGEOMBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGPHYSICSRAYGEOMBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGPHYSICSRAYGEOMFIELDS_HEADER_CVSID;
}

