/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class PhysicsTriMeshGeom!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILEPHYSICSTRIMESHGEOMINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGPhysicsTriMeshGeomBase.h"
#include "OSGPhysicsTriMeshGeom.h"


OSG_USING_NAMESPACE

const OSG::BitVector  PhysicsTriMeshGeomBase::GeometryNodeFieldMask = 
    (TypeTraits<BitVector>::One << PhysicsTriMeshGeomBase::GeometryNodeFieldId);

const OSG::BitVector PhysicsTriMeshGeomBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var NodePtr         PhysicsTriMeshGeomBase::_sfGeometryNode
    this node should contain a geometrynode core with geo data!
*/

//! PhysicsTriMeshGeom description

FieldDescription *PhysicsTriMeshGeomBase::_desc[] = 
{
    new FieldDescription(SFNodePtr::getClassType(), 
                     "geometryNode", 
                     GeometryNodeFieldId, GeometryNodeFieldMask,
                     false,
                     (FieldAccessMethod) &PhysicsTriMeshGeomBase::getSFGeometryNode)
};


FieldContainerType PhysicsTriMeshGeomBase::_type(
    "PhysicsTriMeshGeom",
    "PhysicsGeom",
    NULL,
    (PrototypeCreateF) &PhysicsTriMeshGeomBase::createEmpty,
    PhysicsTriMeshGeom::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(PhysicsTriMeshGeomBase, PhysicsTriMeshGeomPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &PhysicsTriMeshGeomBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &PhysicsTriMeshGeomBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr PhysicsTriMeshGeomBase::shallowCopy(void) const 
{ 
    PhysicsTriMeshGeomPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const PhysicsTriMeshGeom *>(this)); 

    return returnValue; 
}

UInt32 PhysicsTriMeshGeomBase::getContainerSize(void) const 
{ 
    return sizeof(PhysicsTriMeshGeom); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsTriMeshGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((PhysicsTriMeshGeomBase *) &other, whichField);
}
#else
void PhysicsTriMeshGeomBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((PhysicsTriMeshGeomBase *) &other, whichField, sInfo);
}
void PhysicsTriMeshGeomBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void PhysicsTriMeshGeomBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

PhysicsTriMeshGeomBase::PhysicsTriMeshGeomBase(void) :
    _sfGeometryNode           (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

PhysicsTriMeshGeomBase::PhysicsTriMeshGeomBase(const PhysicsTriMeshGeomBase &source) :
    _sfGeometryNode           (source._sfGeometryNode           ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

PhysicsTriMeshGeomBase::~PhysicsTriMeshGeomBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 PhysicsTriMeshGeomBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (GeometryNodeFieldMask & whichField))
    {
        returnValue += _sfGeometryNode.getBinSize();
    }


    return returnValue;
}

void PhysicsTriMeshGeomBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (GeometryNodeFieldMask & whichField))
    {
        _sfGeometryNode.copyToBin(pMem);
    }


}

void PhysicsTriMeshGeomBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (GeometryNodeFieldMask & whichField))
    {
        _sfGeometryNode.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void PhysicsTriMeshGeomBase::executeSyncImpl(      PhysicsTriMeshGeomBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (GeometryNodeFieldMask & whichField))
        _sfGeometryNode.syncWith(pOther->_sfGeometryNode);


}
#else
void PhysicsTriMeshGeomBase::executeSyncImpl(      PhysicsTriMeshGeomBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (GeometryNodeFieldMask & whichField))
        _sfGeometryNode.syncWith(pOther->_sfGeometryNode);



}

void PhysicsTriMeshGeomBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<PhysicsTriMeshGeomPtr>::_type("PhysicsTriMeshGeomPtr", "PhysicsGeomPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(PhysicsTriMeshGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(PhysicsTriMeshGeomPtr, OSG_CONTRIBLIB_DLLTMPLMAPPING);

OSG_END_NAMESPACE


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: OSGPhysicsTriMeshGeomBase.cpp,v 1.2 2006/02/20 17:04:21 dirk Exp $";
    static Char8 cvsid_hpp       [] = OSGPHYSICSTRIMESHGEOMBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGPHYSICSTRIMESHGEOMBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGPHYSICSTRIMESHGEOMFIELDS_HEADER_CVSID;
}

