/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class SwitchMaterial!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILESWITCHMATERIALINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGSwitchMaterialBase.h"
#include "OSGSwitchMaterial.h"


OSG_USING_NAMESPACE

const OSG::BitVector  SwitchMaterialBase::MaterialsFieldMask = 
    (TypeTraits<BitVector>::One << SwitchMaterialBase::MaterialsFieldId);

const OSG::BitVector  SwitchMaterialBase::ChoiceFieldMask = 
    (TypeTraits<BitVector>::One << SwitchMaterialBase::ChoiceFieldId);

const OSG::BitVector SwitchMaterialBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var MaterialPtr     SwitchMaterialBase::_mfMaterials
    
*/
/*! \var UInt32          SwitchMaterialBase::_sfChoice
    
*/

//! SwitchMaterial description

FieldDescription *SwitchMaterialBase::_desc[] = 
{
    new FieldDescription(MFMaterialPtr::getClassType(), 
                     "materials", 
                     MaterialsFieldId, MaterialsFieldMask,
                     false,
                     (FieldAccessMethod) &SwitchMaterialBase::getMFMaterials),
    new FieldDescription(SFUInt32::getClassType(), 
                     "choice", 
                     ChoiceFieldId, ChoiceFieldMask,
                     false,
                     (FieldAccessMethod) &SwitchMaterialBase::getSFChoice)
};


FieldContainerType SwitchMaterialBase::_type(
    "SwitchMaterial",
    "Material",
    NULL,
    (PrototypeCreateF) &SwitchMaterialBase::createEmpty,
    SwitchMaterial::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(SwitchMaterialBase, SwitchMaterialPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &SwitchMaterialBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &SwitchMaterialBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr SwitchMaterialBase::shallowCopy(void) const 
{ 
    SwitchMaterialPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const SwitchMaterial *>(this)); 

    return returnValue; 
}

UInt32 SwitchMaterialBase::getContainerSize(void) const 
{ 
    return sizeof(SwitchMaterial); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void SwitchMaterialBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((SwitchMaterialBase *) &other, whichField);
}
#else
void SwitchMaterialBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((SwitchMaterialBase *) &other, whichField, sInfo);
}
void SwitchMaterialBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void SwitchMaterialBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

    _mfMaterials.terminateShare(uiAspect, this->getContainerSize());
}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

SwitchMaterialBase::SwitchMaterialBase(void) :
    _mfMaterials              (), 
    _sfChoice                 (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

SwitchMaterialBase::SwitchMaterialBase(const SwitchMaterialBase &source) :
    _mfMaterials              (source._mfMaterials              ), 
    _sfChoice                 (source._sfChoice                 ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

SwitchMaterialBase::~SwitchMaterialBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 SwitchMaterialBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        returnValue += _mfMaterials.getBinSize();
    }

    if(FieldBits::NoField != (ChoiceFieldMask & whichField))
    {
        returnValue += _sfChoice.getBinSize();
    }


    return returnValue;
}

void SwitchMaterialBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        _mfMaterials.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ChoiceFieldMask & whichField))
    {
        _sfChoice.copyToBin(pMem);
    }


}

void SwitchMaterialBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        _mfMaterials.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ChoiceFieldMask & whichField))
    {
        _sfChoice.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void SwitchMaterialBase::executeSyncImpl(      SwitchMaterialBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.syncWith(pOther->_mfMaterials);

    if(FieldBits::NoField != (ChoiceFieldMask & whichField))
        _sfChoice.syncWith(pOther->_sfChoice);


}
#else
void SwitchMaterialBase::executeSyncImpl(      SwitchMaterialBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (ChoiceFieldMask & whichField))
        _sfChoice.syncWith(pOther->_sfChoice);


    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.syncWith(pOther->_mfMaterials, sInfo);


}

void SwitchMaterialBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.beginEdit(uiAspect, uiContainerSize);

}
#endif



#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<SwitchMaterialPtr>::_type("SwitchMaterialPtr", "MaterialPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(SwitchMaterialPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(SwitchMaterialPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);

OSG_END_NAMESPACE


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: OSGSwitchMaterialBase.cpp,v 1.2 2006/02/20 17:04:44 dirk Exp $";
    static Char8 cvsid_hpp       [] = OSGSWITCHMATERIALBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGSWITCHMATERIALBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGSWITCHMATERIALFIELDS_HEADER_CVSID;
}

