/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class State!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILESTATEINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGStateBase.h"
#include "OSGState.h"


OSG_USING_NAMESPACE

const OSG::BitVector  StateBase::ChunksFieldMask = 
    (TypeTraits<BitVector>::One << StateBase::ChunksFieldId);

const OSG::BitVector StateBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var StateChunkPtr   StateBase::_mfChunks
    
*/

//! State description

FieldDescription *StateBase::_desc[] = 
{
    new FieldDescription(MFStateChunkPtr::getClassType(), 
                     "chunks", 
                     ChunksFieldId, ChunksFieldMask,
                     false,
                     (FieldAccessMethod) &StateBase::getMFChunks)
};


FieldContainerType StateBase::_type(
    "State",
    "FieldContainer",
    NULL,
    (PrototypeCreateF) &StateBase::createEmpty,
    State::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(StateBase, StatePtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &StateBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &StateBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr StateBase::shallowCopy(void) const 
{ 
    StatePtr returnValue; 

    newPtr(returnValue, dynamic_cast<const State *>(this)); 

    return returnValue; 
}

UInt32 StateBase::getContainerSize(void) const 
{ 
    return sizeof(State); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void StateBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((StateBase *) &other, whichField);
}
#else
void StateBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((StateBase *) &other, whichField, sInfo);
}
void StateBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void StateBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

    _mfChunks.terminateShare(uiAspect, this->getContainerSize());
}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

StateBase::StateBase(void) :
    _mfChunks                 (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

StateBase::StateBase(const StateBase &source) :
    _mfChunks                 (source._mfChunks                 ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

StateBase::~StateBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 StateBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (ChunksFieldMask & whichField))
    {
        returnValue += _mfChunks.getBinSize();
    }


    return returnValue;
}

void StateBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (ChunksFieldMask & whichField))
    {
        _mfChunks.copyToBin(pMem);
    }


}

void StateBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (ChunksFieldMask & whichField))
    {
        _mfChunks.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void StateBase::executeSyncImpl(      StateBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (ChunksFieldMask & whichField))
        _mfChunks.syncWith(pOther->_mfChunks);


}
#else
void StateBase::executeSyncImpl(      StateBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);


    if(FieldBits::NoField != (ChunksFieldMask & whichField))
        _mfChunks.syncWith(pOther->_mfChunks, sInfo);


}

void StateBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

    if(FieldBits::NoField != (ChunksFieldMask & whichField))
        _mfChunks.beginEdit(uiAspect, uiContainerSize);

}
#endif



#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<StatePtr>::_type("StatePtr", "FieldContainerPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(StatePtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(StatePtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);

OSG_END_NAMESPACE


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.45 2005/07/20 00:10:14 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGSTATEBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGSTATEBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGSTATEFIELDS_HEADER_CVSID;
}

