/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class ResolutionDisplayFilter!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILERESOLUTIONDISPLAYFILTERINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGResolutionDisplayFilterBase.h"
#include "OSGResolutionDisplayFilter.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  ResolutionDisplayFilterBase::DownScaleFieldMask = 
    (TypeTraits<BitVector>::One << ResolutionDisplayFilterBase::DownScaleFieldId);

const OSG::BitVector ResolutionDisplayFilterBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var Real32          ResolutionDisplayFilterBase::_sfDownScale
    
*/

//! ResolutionDisplayFilter description

FieldDescription *ResolutionDisplayFilterBase::_desc[] = 
{
    new FieldDescription(SFReal32::getClassType(), 
                     "downScale", 
                     DownScaleFieldId, DownScaleFieldMask,
                     false,
                     (FieldAccessMethod) &ResolutionDisplayFilterBase::getSFDownScale)
};


FieldContainerType ResolutionDisplayFilterBase::_type(
    "ResolutionDisplayFilter",
    "DisplayFilter",
    NULL,
    (PrototypeCreateF) &ResolutionDisplayFilterBase::createEmpty,
    ResolutionDisplayFilter::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(ResolutionDisplayFilterBase, ResolutionDisplayFilterPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &ResolutionDisplayFilterBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &ResolutionDisplayFilterBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr ResolutionDisplayFilterBase::shallowCopy(void) const 
{ 
    ResolutionDisplayFilterPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const ResolutionDisplayFilter *>(this)); 

    return returnValue; 
}

UInt32 ResolutionDisplayFilterBase::getContainerSize(void) const 
{ 
    return sizeof(ResolutionDisplayFilter); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void ResolutionDisplayFilterBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl((ResolutionDisplayFilterBase *) &other, whichField);
}
#else
void ResolutionDisplayFilterBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((ResolutionDisplayFilterBase *) &other, whichField, sInfo);
}
void ResolutionDisplayFilterBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void ResolutionDisplayFilterBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

ResolutionDisplayFilterBase::ResolutionDisplayFilterBase(void) :
    _sfDownScale              (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

ResolutionDisplayFilterBase::ResolutionDisplayFilterBase(const ResolutionDisplayFilterBase &source) :
    _sfDownScale              (source._sfDownScale              ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

ResolutionDisplayFilterBase::~ResolutionDisplayFilterBase(void)
{
}

/*------------------------------ access -----------------------------------*/

UInt32 ResolutionDisplayFilterBase::getBinSize(const BitVector &whichField)
{
    UInt32 returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (DownScaleFieldMask & whichField))
    {
        returnValue += _sfDownScale.getBinSize();
    }


    return returnValue;
}

void ResolutionDisplayFilterBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (DownScaleFieldMask & whichField))
    {
        _sfDownScale.copyToBin(pMem);
    }


}

void ResolutionDisplayFilterBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (DownScaleFieldMask & whichField))
    {
        _sfDownScale.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void ResolutionDisplayFilterBase::executeSyncImpl(      ResolutionDisplayFilterBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (DownScaleFieldMask & whichField))
        _sfDownScale.syncWith(pOther->_sfDownScale);


}
#else
void ResolutionDisplayFilterBase::executeSyncImpl(      ResolutionDisplayFilterBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (DownScaleFieldMask & whichField))
        _sfDownScale.syncWith(pOther->_sfDownScale);



}

void ResolutionDisplayFilterBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



OSG_END_NAMESPACE

#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<ResolutionDisplayFilterPtr>::_type("ResolutionDisplayFilterPtr", "DisplayFilterPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(ResolutionDisplayFilterPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(ResolutionDisplayFilterPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.46 2006/03/16 17:01:53 dirk Exp $";
    static Char8 cvsid_hpp       [] = OSGRESOLUTIONDISPLAYFILTERBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGRESOLUTIONDISPLAYFILTERBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGRESOLUTIONDISPLAYFILTERFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

